/**
 * name: use-spotlight@1.0.3
 * desc: A react hook that generates 'spotlight' for active target.
 * author: 9am <tech.9am@gmail.com> [https://9am.github.io/]
 * homepage: https://github.com/9am/use-spotlight#readme
 * license: MIT
 */
import { useState as g, useRef as R, useCallback as b, useEffect as v } from "react";
const S = [0, 0, 0, 0], c = { x: 0, y: 0, width: 0, height: 0 }, w = (t, s) => {
  var i;
  try {
    return +(((i = getComputedStyle(t, null)) == null ? void 0 : i.getPropertyValue(s)) ?? "").replace("px", "");
  } catch {
    return 0;
  }
}, z = (t) => {
  const s = (t == null ? void 0 : t.getBoundingClientRect()) ?? c;
  return {
    ...s,
    x: s.x - ((t == null ? void 0 : t.scrollLeft) ?? 0) + w(t, "border-left-width"),
    y: s.y - ((t == null ? void 0 : t.scrollTop) ?? 0) + w(t, "border-top-width")
  };
}, $ = ([t, s, i, r]) => ({
  "--spotlight-x": `${t}px`,
  "--spotlight-y": `${s}px`,
  "--spotlight-w": `${i}px`,
  "--spotlight-h": `${r}px`,
  "--spotlight-duration": "200ms",
  "--spotlight-bg": "rgba(255, 0, 0, 0.1)",
  content: '""',
  display: "block",
  boxSizing: "border-box",
  position: "absolute",
  top: "0px",
  left: "0px",
  width: "var(--spotlight-w)",
  height: "var(--spotlight-h)",
  transform: "translate(var(--spotlight-x), var(--spotlight-y))",
  transitionProperty: "transform, width, height",
  transitionDuration: "var(--spotlight-duration)",
  background: "var(--spotlight-bg)",
  pointerEvents: "none"
}), B = (t = {}) => {
  const [s, i] = g(S), [r, p] = g(c), [o, h] = g(c);
  let u = R(null), y = R(null);
  const d = b(
    (e) => {
      u.current = e, p(z(e));
    },
    [p]
  ), m = b(
    (e) => {
      y.current = e, h((e == null ? void 0 : e.getBoundingClientRect()) ?? c);
    },
    [h]
  );
  return v(() => {
    i([
      o.x - r.x,
      o.y - r.y,
      o.width,
      o.height
    ]);
  }, [r, o, i]), v(() => {
    const e = u.current, a = y.current;
    if (!e || !a)
      return () => i(S);
    let l = null;
    const x = () => {
      const f = z(e), n = a.getBoundingClientRect();
      i([n.x - f.x, n.y - f.y, n.width, n.height]);
    };
    typeof ResizeObserver < "u" && (l = new ResizeObserver(x), l.observe(e), l.observe(a)), x();
    const C = e.style.position;
    return e.style.position = "relative", () => {
      e.style.position = C, l == null || l.disconnect();
    };
  }, [r, o, i]), {
    stage: d,
    actor: m,
    style: $(s),
    size: s
  };
}, E = null;
export {
  E as default,
  B as useSpotlight
};
