import type { Size } from './types';
export declare const useSpotlight: (options?: {}) => {
    stage: (node: HTMLElement) => void;
    actor: (node: HTMLElement) => void;
    style: {
        '--spotlight-x': string;
        '--spotlight-y': string;
        '--spotlight-w': string;
        '--spotlight-h': string;
        '--spotlight-duration': string;
        '--spotlight-bg': string;
        content: string;
        display: string;
        boxSizing: string;
        position: string;
        top: string;
        left: string;
        width: string;
        height: string;
        transform: string;
        transitionProperty: string;
        transitionDuration: string;
        background: string;
        pointerEvents: string;
    };
    size: Size;
};
export type { Size, Rect } from './types';
declare const _default: null;
export default _default;
