/**
 * name: use-spotlight@1.0.3
 * desc: A react hook that generates 'spotlight' for active target.
 * author: 9am <tech.9am@gmail.com> [https://9am.github.io/]
 * homepage: https://github.com/9am/use-spotlight#readme
 * license: MIT
 */
(function(n,i){typeof exports=="object"&&typeof module<"u"?i(exports,require("react")):typeof define=="function"&&define.amd?define(["exports","react"],i):(n=typeof globalThis<"u"?globalThis:n||self,i(n.Spotlight={},n.React))})(this,function(n,i){"use strict";const g=[0,0,0,0],u={x:0,y:0,width:0,height:0},h=(t,s)=>{var o;try{return+(((o=getComputedStyle(t,null))==null?void 0:o.getPropertyValue(s))??"").replace("px","")}catch{return 0}},f=t=>{const s=(t==null?void 0:t.getBoundingClientRect())??u;return{...s,x:s.x-((t==null?void 0:t.scrollLeft)??0)+h(t,"border-left-width"),y:s.y-((t==null?void 0:t.scrollTop)??0)+h(t,"border-top-width")}},S=([t,s,o,l])=>({"--spotlight-x":`${t}px`,"--spotlight-y":`${s}px`,"--spotlight-w":`${o}px`,"--spotlight-h":`${l}px`,"--spotlight-duration":"200ms","--spotlight-bg":"rgba(255, 0, 0, 0.1)",content:'""',display:"block",boxSizing:"border-box",position:"absolute",top:"0px",left:"0px",width:"var(--spotlight-w)",height:"var(--spotlight-h)",transform:"translate(var(--spotlight-x), var(--spotlight-y))",transitionProperty:"transform, width, height",transitionDuration:"var(--spotlight-duration)",background:"var(--spotlight-bg)",pointerEvents:"none"}),w=(t={})=>{const[s,o]=i.useState(g),[l,y]=i.useState(u),[r,x]=i.useState(u);let R=i.useRef(null),b=i.useRef(null);const m=i.useCallback(e=>{R.current=e,y(f(e))},[y]),C=i.useCallback(e=>{b.current=e,x((e==null?void 0:e.getBoundingClientRect())??u)},[x]);return i.useEffect(()=>{o([r.x-l.x,r.y-l.y,r.width,r.height])},[l,r,o]),i.useEffect(()=>{const e=R.current,p=b.current;if(!e||!p)return()=>o(g);let c=null;const d=()=>{const v=f(e),a=p.getBoundingClientRect();o([a.x-v.x,a.y-v.y,a.width,a.height])};typeof ResizeObserver<"u"&&(c=new ResizeObserver(d),c.observe(e),c.observe(p)),d();const k=e.style.position;return e.style.position="relative",()=>{e.style.position=k,c==null||c.disconnect()}},[l,r,o]),{stage:m,actor:C,style:S(s),size:s}},z=null;n.default=z,n.useSpotlight=w,Object.defineProperties(n,{__esModule:{value:!0},[Symbol.toStringTag]:{value:"Module"}})});
